SystemOrganization addCategory: #'Conman-Core'!
SystemOrganization addCategory: #'Conman-Core-Tests'!
SystemOrganization addCategory: #'Conman-Web'!

WAComponent subclass: #CMComponent
	instanceVariableNames: 'enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:35'!
ajax
	^self session ajax! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:35'!
ajax: aBoolean
	self session ajax: aBoolean! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
convention
	^self session convention! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:11'!
disable
	enabled := false.! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enable
	enabled := self convention notNil.! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:10'!
enabled
	^enabled! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:10'!
initialize
	super initialize.
	enabled := true.! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:10'!
title
	^self subclassResponsibility.! !

CMComponent subclass: #CMConman
	instanceVariableNames: 'children content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMConman class methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 21:45'!
canBeRoot
	^true! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:04'!
children
	^Array with: content.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:15'!
initialize
	super initialize.
	children := OrderedCollection new.
	content := children add: CMHome new.
	children add: CMParticipants new.
	children add: CMLoadSave new.
! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:03'!
renderContentOn: html
	html div id: 'heading'; with: [
		self renderHeadingOn: html.
	].
	html div id: 'nav'; with: [
		self renderNavOn: html.
	].
	html div id: 'content'; with: [
		html render: content.
	].! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:18'!
renderHeadingOn: html
	html heading level: 1; with: 'Conman'.
	self convention ifNotNil: [ html heading level: 2; with: self convention name ].
! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:47'!
renderNavOn: html.
	html unorderedList: [ children do: [ :c | c enabled ifTrue: [
		html listItem class: ((c = content) ifTrue:  ['active'] ifFalse: ['']); with: [ 
			html anchor 
				callback: [ content := c ]; 
				onClick:  (self ajax ifTrue: [html updater id: 'content'; callback: [ :r | content := c. r render: content ]; return: false]);
				with: c title ]]].
		html listItem: [ html anchor callback: [ self ajax: self ajax not ]; with: (self ajax ifTrue: ['Disable'] ifFalse: ['Enable']), ' Ajax']
	
].! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 00:26'!
style ^ '#heading h1 { display: inline; margin-right: 1em;}
#heading h2 { display: inline;}
#heading { 
	margin-bottom: 0px; 
	border-bottom-style: solid; 
	border-bottom-width: 1px;
}
#nav ul {
	margin: 0;
}
#nav li {
	display: inline;
	padding-left: 0.25em;
	padding-right: 0.25em;
	background: #ccc;
	margin-right: 2px;
	border-style: solid;
	border-width: 1px;
}
#nav li.active {
	background: #eee;
}
#nav li a {
	text-decoration: none;
}
#nav {
	padding-bottom: 0px; 
	padding-top: 0px;
	margin-bottom: 0.5em;
	margin-top: 0px;
}
'! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 00:09'!
updateRoot: anHtmlRoot
	| t |
	super updateRoot: anHtmlRoot.
	t := 'Conman'.
	self convention ifNotNil: [ t := t, ': ', self convention name ].
	anHtmlRoot title: t.! !

CMComponent subclass: #CMHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enabled
	^true! !

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:50'!
renderContentOn: html
	self convention ifNotNil: [
		html paragraph: 'Events: ', self convention events size printString.
		html paragraph: 'Rooms: ', self convention rooms size printString.
		html paragraph: 'Participants: ', self convention participants size printString.
	]! !

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:15'!
title
	^'Home'! !

CMComponent subclass: #CMLoadSave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enabled
	^true! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:17'!
renderContentOn: html
	self convention ifNotNil: [
		self renderSaveBoxOn: html.
	].
	self renderLoadListOn: html.! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:17'!
renderLoadListOn: html
	html unorderedList: [
		CMConvention listSaved do: [ :name |
			html listItem: [
				html anchor callback: [
					 self session convention: (CMConvention loadFrom: name) 
				]; with: name.
			]
		]
	].! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:17'!
renderSaveBoxOn: html
	html form: [
		html label for: 'saveCon'.
		html textInput id: 'saveCon'; callback: [ :val |
			self convention saveAs: val.	
		].
		html submitButton value: 'Save'.
	]! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 00:10'!
style ^ ''! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:15'!
title
	^'Load and Save'! !

CMComponent subclass: #CMParticipantEditor
	instanceVariableNames: 'participant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipantEditor class methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 20:59'!
for: aParticipant
	^self new participant: aParticipant! !

!CMParticipantEditor methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:20'!
cancel
	self answer: false.! !

!CMParticipantEditor methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:00'!
participant: aParticipant
	participant := aParticipant! !

!CMParticipantEditor methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:17'!
render: anInputType on: aSelector of: anObject titled: aTitle on: html
	html div: [
		html label for: aSelector; with: aTitle, ': ' .
		(html perform: anInputType) on: aSelector of: anObject; id: aSelector
	]
! !

!CMParticipantEditor methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:20'!
renderContentOn: html
	html form: [
		self render: #textInput on: #name of: participant titled: 'Name' on: html.
		self render: #textArea on: #bio of: participant titled: 'Bio' on: html.
		html submitButton on: #save of: self.
		html cancelButton on: #cancel of: self
	].! !

!CMParticipantEditor methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:20'!
save
	self answer: true.! !

CMComponent subclass: #CMParticipantList
	instanceVariableNames: 'report viewer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipantList methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:25'!
add
	| p editor |
	p := CMParticipant new.
	editor := CMParticipantEditor for: p.
	(self call: editor) ifTrue: [ self convention addParticipant: p ]! !

!CMParticipantList methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 22:03'!
children
	^Array with: viewer.! !

!CMParticipantList methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 22:06'!
initialize
	super initialize.
	viewer := CMParticipantView new.! !

!CMParticipantList methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:30'!
renderContentOn: html
	html div id: #viewParticipant; with: [ self renderParticipantOn: html ].
	html unorderedList: [
		self convention participants do: [ :p |
			html listItem: [ 
				html anchor callback: [ self viewParticipant: p ]; with: p name. 
				html space.
				html anchor callback: [viewer participant: p]; onClick: (self ajax ifTrue: [
					html updater id: #viewParticipant; callback: [ :r | viewer participant: p. self renderParticipantOn: r]; return: false 
				]); with: 'view'.

			].
		]
	].
	html anchor callback: [ self add ]; with: 'Add Participant'.! !

!CMParticipantList methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 22:49'!
renderParticipantOn: html
	html render: viewer ! !

!CMParticipantList methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 20:58'!
viewParticipant: aParticipant
	self call: (CMParticipantEditor for: aParticipant).! !

CMComponent subclass: #CMParticipantView
	instanceVariableNames: 'participant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipantView class methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:32'!
for: aParticipant
	^self new participant: aParticipant; yourself.! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:32'!
participant: aParticipant
	participant := aParticipant.! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:28'!
renderContentOn: html
	participant ifNotNil: [
		html div id: 'participantView'; with: [
			html heading level: 3; with: participant name.
			html paragraph: participant bio.
		]
	].! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:13'!
style ^ 'div#participantView {
    border-style: solid;
    border-width: 1px;
}

#participantView h3 {
    margin-top: 0;
}
'! !

CMComponent subclass: #CMParticipants
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipants methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 19:10'!
children
	^Array with: list.! !

!CMParticipants methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
enabled
	^self session convention notNil! !

!CMParticipants methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 19:10'!
initialize
	super initialize.
	list := CMParticipantList new.! !

!CMParticipants methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 19:14'!
renderContentOn: html
	html render: list
! !

!CMParticipants methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:15'!
title
	^'Participants'! !

Object subclass: #CMConvention
	instanceVariableNames: 'rooms events participants name'
	classVariableNames: 'Suffix Prefix'
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:44'!
deserialize: aString
	^Object readSixxFrom: aString! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:47'!
filenameFrom: aFilename
	" Use a template to create a filename from the unique portion "
	^ Prefix, aFilename , Suffix.! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:48'!
initialize
	super initialize.
	Prefix := 'Conman-'.
	Suffix := '.xml'.! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:49'!
listSaved
	^ (FileDirectory default fileNamesMatching: Prefix, '*', Suffix) collect: [ :n|
		n copyFrom: Prefix size + 1 to: n size - Suffix size ].! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:29'!
loadFrom: aFilename
	| fstream c |
	fstream := FileDirectory default readOnlyFileNamed: (self filenameFrom: aFilename).
	c := Object readSixxFrom: fstream.
	fstream close.
	^c.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:49'!
addEvent: anEvent
	events add: anEvent.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:50'!
addParticipant: aParticipant
	participants add: aParticipant! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:49'!
addRoom: aRoom
	rooms add: aRoom! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:48'!
events
	^events! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:38'!
initialize
	rooms := Set new.
	events := Set new.
	participants := Set new.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:11'!
name
	^name! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:10'!
name: aName
	name := aName.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:48'!
participants
	^participants! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:09'!
removeEvent: anEvent
	anEvent dispose.
	events remove: anEvent.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:17'!
removeParticipant: aParticipant
	aParticipant dispose.
	participants remove: aParticipant.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:11'!
removeRoom: aRoom
	aRoom dispose.
	rooms remove: aRoom.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:48'!
rooms
	^rooms! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:26'!
saveAs: aFilename
	| fstream |
	fstream := FileDirectory default forceNewFileNamed: (CMConvention filenameFrom: aFilename).
	fstream write: self serialize.
	fstream close.
! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:43'!
serialize
	" Convert the Convention and its members to a string that can be used
	 to reconstitute the Convention via CMConvention deserialise:"
	
	^self sixxString.! !

Object subclass: #CMEvent
	instanceVariableNames: 'description duration name participants room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:21'!
add: aParticipant
	participants add: aParticipant.
	aParticipant myAddEvent: self! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:38'!
deschedule
	room ifNotNil: [room deschedule: self].! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description
	^ description! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description: anObject
	description := anObject! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:10'!
dispose
	self deschedule.
	participants do: [ :p | self remove: p].! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration
	^ duration! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration: anObject
	duration := anObject! !

!CMEvent methodsFor: 'initialize-release' stamp: 'srh 5/23/2007 22:32'!
initialize
	participants := Set new! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name
	^ name! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
name: anObject
	name := anObject! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
participants
	^ participants! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:22'!
remove: aParticipant
	participants remove: aParticipant.
	aParticipant myRemoveEvent: self! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/24/2007 15:16'!
room
	^room! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:12'!
scheduleAt: aTime in: aRoom
	aRoom schedule: self at: aTime.! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:07'!
scheduled
	^room notNil.! !

!CMEvent methodsFor: 'private' stamp: 'srh 5/24/2007 15:08'!
setRoom: aRoom
	room := aRoom! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
time
	^ room scheduleFor: self! !

Object subclass: #CMParticipant
	instanceVariableNames: 'bio name events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

CMParticipant class
	instanceVariableNames: 'events'!

CMParticipant class
	instanceVariableNames: 'events'!

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:23'!
attend: anEvent
	anEvent add: self! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio
	^ bio! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio: anObject
	bio := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:18'!
dispose
	events do: [ :e | self unattend: e].! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 23:20'!
events
	^events! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:21'!
initialize
	events := Set new.! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/23/2007 23:19'!
myAddEvent: anEvent
	events add: anEvent.! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/24/2007 07:22'!
myRemoveEvent: anEvent
	events remove: anEvent! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:16'!
timetable
	| t |
	t := SortedCollection sortBlock: [ :a :b | a time < b time].
	events do: [ :event | 
		event scheduled ifTrue: [
			t add: (CMScheduleItem newEvent: event in: event room at: event time) 
		]].
	^t.! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:19'!
unattend: anEvent
	anEvent remove: self! !

Object subclass: #CMRoom
	instanceVariableNames: 'capacity description name schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity
	^ capacity! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity: anObject
	capacity := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:27'!
deschedule: anEvent
	(schedule includesKey: anEvent) ifTrue: [
		schedule removeKey: anEvent.
		anEvent setRoom: nil.
	].! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description
	^ description! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description: anObject
	description := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:14'!
dispose
	schedule keys do: [ :e | self deschedule: e ].! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/24/2007 15:15'!
events
	^schedule keys! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:14'!
initialize
	schedule := Dictionary new.! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:37'!
schedule: anEvent at: aDateAndTime
	anEvent deschedule.
	schedule at: anEvent put: aDateAndTime.
	anEvent setRoom: self! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:15'!
scheduleFor: anEvent
	^schedule at: anEvent! !

Object subclass: #CMScheduleItem
	instanceVariableNames: 'room event time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMScheduleItem class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:09'!
newEvent: anEvent in: aRoom at: aTime
	^(self new) setEvent: anEvent room: aRoom time: aTime.! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
event
	^event! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
room
	^room! !

!CMScheduleItem methodsFor: 'private' stamp: 'srh 5/24/2007 20:09'!
setEvent: anEvent room: aRoom time: aTime
	room := aRoom.
	event := anEvent.
	time := aTime.! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
time
	^time! !

WASession subclass: #CMSession
	instanceVariableNames: 'convention ajax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:31'!
ajax
	^ajax! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:31'!
ajax: aBoolean
	ajax := aBoolean! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
convention
	^convention.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
convention: aCMConvention
	convention := aCMConvention.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:31'!
initialize
	super initialize.
	ajax := true.! !

TestCase subclass: #CMConventionTest
	instanceVariableNames: 'c e r p time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:09'!
assertDeserialization: c2
	" Check that c2 is the same as c as set up by standardSetUp"
	| e2 r2 p2 tt |

	self assert: c name = c2 name.
	
	" Verify the basic collections are the same - as far as we can "
	self assert: c rooms size = c2 rooms size.
	self assert: c events size = c2 events size.
	self assert: c participants size = c2 participants size .

	" Now ensure the relationships are kept "
	e2 := c2 events asOrderedCollection at: 1.
	r2 := c2 rooms asOrderedCollection at: 1.
	p2 := c2 participants asOrderedCollection at: 1.
	tt := p2 timetable at: 1.
		
	self assert: r2 = e2 room.
	self assert: e2 = (r2 events asOrderedCollection at: 1).
	self assert: e2 = tt event.
	self assert: r2 = tt room.
	self assert: time = tt time.
	! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:24'!
setUp
	c := CMConvention new name: 'A Convention'.
	e := CMEvent new name: 'An Event'; description: 'Stuff Happens'.
	r := CMRoom new name: 'A Room'; description: 'It has four walls'; capacity: '20'.
	p := CMParticipant new name: 'A Participant'.
	time := '2007-10-01T10:00:00' asDateAndTime.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:22'!
standardSetUp
	c addEvent: e; addRoom: r; addParticipant: p.
	p attend: e.
	r schedule: e at: time.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
tearDown
	c := nil.
	e := nil.
	r := nil.
	p := nil.
	time := nil.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddEvents
	c addEvent: e.
	self assert: (c events includes: e).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddParticipants
	c addParticipant: p.
	self assert: (c participants includes: p).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddRooms
	c addRoom: r.
	self assert: (c rooms includes: r).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:21'!
testLoadSave
	| c2 |
	self standardSetUp.
	c saveAs: 'testingfile'.
	
	c2 := CMConvention loadFrom: 'testingfile'.
	self assertDeserialization: c2.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
testRemoveEvent
	self	standardSetUp.
	c removeEvent: e.
	
	self assert: (c events includes: e) not.
	self assert: (r events includes: e) not.
	self assert: (p events includes: e) not.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
testRemoveParticipant
	self standardSetUp.
	
	c removeParticipant: p.
	
	self assert: (c participants includes: p) not.
	self assert: (e participants includes: p) not.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:18'!
testRemoveRoom
	self standardSetUp.
		
	c removeRoom: r.
	
	self assert: (c rooms includes: r) not.
	self assert: (e scheduled) not.
	self assert: e room isNil.
	self assert: (p timetable noneSatisfy: [ :s | s room = r ]).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:19'!
testSerialiseDeserialise
	| c2 string |
	self standardSetUp.
	string := c serialize.
	
	c2 := CMConvention deserialize: string.
	self assertDeserialization: c2.! !

TestCase subclass: #CMEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
assert: anEvent scheduledAt: aDateAndTime in: aRoom
	self assert: anEvent scheduled.
	self assert: (aRoom events includes: anEvent).
	self assert: (aRoom scheduleFor: anEvent) = aDateAndTime.
	self assert: anEvent time = aDateAndTime.
	self assert: anEvent room == aRoom! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 14:57'!
testAdd
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	e add: p.
	self assert: e participants size = 1.
	self assert: (e participants includes: p).
	self assert: p events size = 1.
	self assert: (p events includes: e).! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:24'!
testDeschedule
	| e1 r1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	
	e1 scheduleAt: '2007-10-01T09:00:00' asDateAndTime in: r1.	
	e1 deschedule.
	self assert: r1 events size = 0.
	
! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:16'!
testRemove
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	e1 add: p1.
	e1 remove: p1.
	self assert: e1 participants size = 0.
	self assert: p1 events size = 0.! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:25'!
testReschedule
	| e1 r1 r2 t1 t2 |
	r1 := CMRoom new.
	r2 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	t2 := '2007-10-02T17:00:00' asDateAndTime.
	
	e1 scheduleAt: t1 in: r1.	
	e1 scheduleAt: t2 in: r1.
	self assert: e1 scheduledAt: t2 in: r1.
	
	self assert: r1 events size = 1.
	
	e1 scheduleAt: t1 in: r2.
	self assert: e1 scheduledAt: t1 in: r2.
	self assert: r1 events size = 0.
	
	e1 deschedule.
	self assert: r1 events size = 0.
	self assert: r2 events size = 0.
	self assert: e1 scheduled not.
	
! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:23'!
testSchedule
	| e1 r1 t1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	
	e1 scheduleAt: t1 in: r1.	
	self assert: e1 scheduledAt: t1 in: r1.! !

TestCase subclass: #CMParticipantTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 14:58'!
testAttend
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	p attend: e.
	self assert: p events size = 1.
	self assert: (p events includes: e).
	self assert: e participants size = 1.
	self assert: (e participants includes: p).
! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:14'!
testTimetable
	| e1 r1 e2 r2 p t1 t2 |
	
	p := CMParticipant new.
	e1 := CMEvent new.
	e2 := CMEvent new.
	r1 := CMRoom new.
	r2 := CMRoom new.
	t1 := '2007-10-01T09:30:00' asDateAndTime.
	t2 := '2007-10-01T015:00:00' asDateAndTime.

	r1 schedule: e1 at: t1.
	r2 schedule: e2 at: t2.
	
	p attend: e1.
	p attend: e2.
	
	self assert: (p timetable at: 1) room = r1.
	self assert: (p timetable at: 1) event = e1.
	self assert: (p timetable at: 1) time = t1.
	
	self assert: (p timetable at: 2) room = r2.
	self assert: (p timetable at: 2) event = e2.
	self assert: (p timetable at: 2) time = t2.! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:20'!
testUnattend
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	e1 add: p1.
	p1 unattend: e1.
	self assert: e1 participants size = 0.
	self assert: p1 events size = 0.! !

TestCase subclass: #CMRoomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
assert: anEvent scheduledAt: aDateAndTime in: aRoom
	self assert: anEvent scheduled.
	self assert: (aRoom events includes: anEvent).
	self assert: (aRoom scheduleFor: anEvent) = aDateAndTime.
	self assert: anEvent time = aDateAndTime.
	self assert: anEvent room == aRoom! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:00'!
testDeschedule
	| e1 r1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	
	r1 schedule: e1 at: '2007-10-01T09:00:00' asDateAndTime.
	r1 deschedule: e1.
	self assert: r1 events size = 0.
	
! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:03'!
testReschedule
	| e1 r1 r2 t1 t2 |
	r1 := CMRoom new.
	r2 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	t2 := '2007-10-02T17:00:00' asDateAndTime.
	
	r1 schedule: e1 at: t1.	
	r1 schedule: e1 at: t2.
	self assert: e1 scheduledAt: t2 in: r1.
	self assert: r1 events size = 1.
	
	r2 schedule: e1 at: t1.
	self assert: e1 scheduledAt: t1 in: r2.
	self assert: r1 events size = 0.
	
	r2 deschedule: e1.
	self assert: r1 events size = 0.
	self assert: r2 events size = 0.
	self assert: e1 scheduled not.
	
! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:03'!
testSchedule
	| e1 r1 t1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	
	r1 schedule: e1 at: t1.	
	self assert: e1 scheduledAt: t1 in: r1.! !
CMConvention initialize!
